#include <bits/stdc++.h>
#include <ext/rope>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace __gnu_cxx;
using namespace std;

#define int long long
#define ld long double
#define vi vector<int>
#define pb push_back
#define mp make_pair
#define F first
#define S second
#define pii pair<int, int>
#define sz(a) (int)(a.size())
#define all(a) a.begin(), a.end()
#define SORT(a) sort(all(a))
#define inf (int)(1e18)
#define e 1e-7
#define rng(n) for(int _= 0; _ < (int)(n); _++)
#define rngi(i, n) for(int i = 0; i < (int)(n); i++)
#define problem "b"

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

template<typename T>
void print(T a)
{
    for(auto x : a) cout << x << ' '; cout << '\n';
}

signed main()
{
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false); srand(time(NULL));
    //freopen(problem".in", "r", stdin);
    vi primes;
    const int mxn = 10000000;
    vi lp(mxn);
    for(int i = 2; i < mxn; i++)
    {
        if(!lp[i]) lp[i] = i, primes.pb(i);
        for(int j = 0; j < primes.size() && primes[j] <= lp[i] && primes[j] * i < mxn; j++) lp[primes[j] * i] = primes[j];
    }
    vector<vi> primes_for_d(11);
    for(auto x : primes) primes_for_d[to_string(x).size()].pb(x);
    //cout << primes.size() << '\n';
    auto pw = [](int x)
    {
        int ans = 1;
        while(x > 0) ans *= 10, x--;
        return ans;
    };
    auto solve = [&]()
    {
        int res = inf;
        int d, n; cin >> d >> n; string nn = to_string(n);
        for(int d1 = d; d1 < nn.size(); d1++)
        {
            int d2 = sz(nn) - d1; if(d2 < d) break;
            int ans = 0;
            for(int i = 0; i < d1; i++)  ans = ans * 10 + (nn[i] - '0');
            if(binary_search(all(primes), ans))
            {
                int p1 = ans;
                ans = nn[d1] - '0';
                if(!ans) ans = 1;
                for(int i = d1 + 1; i <sz(nn); i++) ans = ans * 10 + (nn[i] - '0');
                int p2 = *lower_bound(all(primes), ans);
                res = min(res, pw(sz(nn) - d1) * p1 + p2);
            }
            else
            {
                int p1 = *lower_bound(all(primes), ans);
                ans = pw(d2 - 1);
                int p2 = *lower_bound(all(primes), ans);
                res = min(res, pw(sz(nn) - d1) * p1 + p2);
            }
        }
        int sz = max(d + d, sz(nn) + 1);
        for(int d1 = d; d1 < sz && sz - d1 >= d; d1++)
        {
            int d2 = sz - d1;
            int f = pw(d1 - 1);
            int s = pw(d2 - 1);
            int p1 = *lower_bound(all(primes), f);
            int p2 = *lower_bound(all(primes), s);
            res = min(res, pw(sz - d1) * p1 + p2);
        }
        cout << res << '\n';
    };
    int t; cin >> t; rng(t) solve();
    return 0;
}
