#include <iostream>
#include <algorithm>
#include <cmath>
#include <cstdio>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    //freopen("StandardOutput.out", "w", stdout);
    int n, m;
    cin >> n >> m;
    bool matrix[n][n];
    for (int i = 0; i < n; ++ i) {
        for (int j = 0; j < m; ++ j) {
            char t;
            cin >> t;
            if (t == '#') {
                matrix[i][j] = true;
            } else {
                matrix[i][j] = false;
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < n; ++ i) {
        for (int j = 0; j < m; ++ j) {
            if (matrix[i][j]) {
                continue;
            }
            for (int k = j - 1; k > -1 && !matrix[i][k]; -- k) {
                ans ++;
            }
            for (int k = i - 1; k > -1 && !matrix[k][j]; -- k) {
                ans ++;
            }
        }
    }
    cout << ans << endl;
}
